addHook("PreThinkFrame",function(player)
	for player in players.iterate
		if player.valid
		and player.mo and player.mo.valid
		and not player.spectator
		and player.playerstate == PST_LIVE
		and player.mo.skin == "sonic"
		and not P_IsObjectOnGround(player.mo)
		and not (player.pflags & PF_SPINNING)
		and not P_PlayerInPain(player)
			player.cmd.forwardmove = 0
			player.cmd.sidemove = 0
		end
	end
end)

addHook("PlayerThink",function(player)
	if player.valid
	and player.mo and player.mo.valid
	and not player.spectator
	and player.playerstate == PST_LIVE
	and player.mo.skin == "sonic"
		player.rollboost = $ or 0
		
		if player.speed < FixedMul(player.normalspeed,player.mo.scale)
		and P_IsObjectOnGround(player.mo) and player.speed > FixedMul(5<<FRACBITS,player.mo.scale)
			P_Thrust(player.mo,R_PointToAngle2(0,0,player.rmomx,player.rmomy),player.mo.scale/16)
		end
		if player.powers[pw_shield] & SH_WHIRLWIND
		and not P_IsObjectOnGround(player.mo)
			P_SetObjectMomZ(player.mo,FRACUNIT/36,true)
			P_Thrust(player.mo,R_PointToAngle2(0,0,player.rmomx,player.rmomy),player.mo.scale/36)
		end
	end
end)

addHook("SpinSpecial",function(player)
	if player.valid
	and player.mo and player.mo.valid
	and not player.spectator
	and player.playerstate == PST_LIVE
	and player.mo.skin == "sonic"
		if not (player.pflags & PF_SPINDOWN)
			player.rollboost = 0
		end
		if (player.speed > FixedMul(5<<FRACBITS,player.mo.scale) or (not P_IsObjectOnGround(player.mo)))
		and not (player.pflags & PF_SPINNING)
		and not (player.pflags & PF_SPINDOWN)
		and not P_PlayerInPain(player)
			if player.speed < FixedMul(player.runspeed-6*FRACUNIT,player.mo.scale)
			and P_IsObjectOnGround(player.mo)
				player.rollboost = 12
			end
			player.mo.state = S_PLAY_ROLL
			player.pflags = ($&~PF_NOJUMPDAMAGE)|PF_SPINNING
			S_StartSound(player.mo,sfx_thok)
			P_SpawnThokMobj(player)
		end
		if player.speed > FixedMul(5>>FRACBITS,player.mo.scale)
		and P_IsObjectOnGround(player.mo)
		and (player.pflags & PF_SPINNING)
		and (player.pflags & PF_SPINDOWN)
		and player.rollboost
		and not P_PlayerInPain(player)
			player.rollboost = max($-1,0)
			P_Thrust(player.mo,R_PointToAngle2(0,0,player.rmomx,player.rmomy),player.mo.scale/2)
		end
		player.pflags = $|PF_SPINDOWN
		return true
	end
end)